SystemOrganization addCategory: #KinematicTemplates!

SystemWindow subclass: #KinematicWindow
	instanceVariableNames: 'virtualCursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

!KinematicWindow class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 10:00'!
openExample
	|w tpl|
	w := self new .
	tpl := StraightLineTemplate new height: 300; width: 300; top: 30.
	w addMorphBack: tpl.
	w openInWorld.! !

!KinematicWindow methodsFor: 'accessing' stamp: 'carlaGriggio 12/13/2012 00:45'!
handlesMouseOver: evt
	^true! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/10/2012 17:10'!
initialize
	super initialize.
	virtualCursor := World currentHand.
	"virtualCursor := RectangleMorph new width: 10; height: 10."
	"self addMorph: virtualCursor."
	
	self setLabel:'Kinematic Templates'.! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 00:45'!
mouseEnter: event
	super mouseEnter: event.
	self currentHand showTemporaryCursor: Cursor blank.! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/13/2012 00:45'!
mouseLeave: event
	super mouseEnter: event.
	self currentHand showTemporaryCursor: nil! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 09:54'!
virtualCursor
	^virtualCursor ! !

RectangleMorph subclass: #KinematicTemplate
	instanceVariableNames: 'virtualPoint drawnPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!KinematicTemplate class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 09:47'!
openExample
	|w tpl|
	w := SystemWindow new setLabel:'Kinematic Templates'.
	tpl := self new height: 300; width: 300; top: 30.
	w addMorph: tpl.
	w openInWorld.! !

!KinematicTemplate methodsFor: 'accessing' stamp: 'carlaGriggio 12/13/2012 00:45'!
handlesMouseDown: evt
	^true! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/11/2012 19:16'!
mouseDown: event
	super mouseDown: event.
	virtualPoint := event cursorPoint.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/11/2012 19:16'!
mouseMove: event
	
	| p1 poly adjustedEndPoint opposite |
	super mouseMove: event.
	Transcript cr; show: 'kinematic mouse move '. 
	"Parche: agregar el virtualCursor como subMorph del KinematicTemplate, porque al transformar el kinematic template (rotandolo) el virtualCursor desaparece al draguear sobre el template. Creo que 'desaparece' porque las coordenadas del morph ya no son las mismas, y al cambiarle la posicin lo manda al carajo, ya que inspeccionndolo queda en posiciones muy sobre la esquina de la ventana, pero sigue estando ah"
	"self addMorphFront: self virtualCursor."
"	self virtualCursor position: (self newVirtualPointFrom: event).
	drawnPath ifNotNil:[self removeMorph: drawnPath].
	drawnPath := (CurveMorph fromHandFreehand: self virtualCursor ) makeOpen.
	self addMorph: drawnPath.
	"
	adjustedEndPoint :=self newVirtualPointFrom: Sensor cursorPoint.
	drawnPath ifNil:[drawnPath  := (LineMorph from: virtualPoint  to: virtualPoint   color: Color black width: 2) openInWorld].
	"self currentWorld displayWorldSafely; runStepMethods."
			drawnPath setVertices: (drawnPath vertices copyWith: adjustedEndPoint).
				"self currentWorld displayWorldSafely; runStepMethods."
	self virtualCursor position: adjustedEndPoint.  
	self addMorph: drawnPath.
	
! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/11/2012 19:16'!
mouseUp: event
	super mouseUp: event.
	drawnPath := nil! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/10/2012 19:41'!
newVirtualPointFrom: aPoint 
	|delta|
	delta := aPoint  - virtualPoint  . 
	virtualPoint :=  virtualPoint + (self transformedDelta: delta).
			Transcript cr; show: 'virtual ', virtualPoint  asString.
			Transcript cr; show: 'real ', aPoint  asString.
	^virtualPoint! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/6/2012 23:13'!
virtualCursor
	^ self containingWindow virtualCursor ! !

KinematicTemplate subclass: #StraightLineTemplate
	instanceVariableNames: 'startPoint previousEndPoint slope expectedNewEndPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!StraightLineTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/5/2012 10:36'!
mouseDown: event
	startPoint := event cursorPoint.
	super mouseDown: event.! !

!StraightLineTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/10/2012 19:41'!
transformedDelta: anOffsetPoint
	|eventSlope|
	"eventSlope :=( mouseEvent endPoint x - startPoint x) / ((mouseEvent endPoint y - startPoint y)).
	slope := 1.
	expectedNewEndPoint := mouseEvent endPoint x @ (mouseEvent endPoint x * slope).
	Transcript cr; show: 'expected: ', expectedNewEndPoint asString.

	^ (anOffsetPoint x * 1) @ (anOffsetPoint y * (slope * eventSlope * 0.9))"
	^ (anOffsetPoint x * 1) @ (anOffsetPoint y * 0.1)! !
